#property indicator_separate_window
#property indicator_buffers 0
#property strict


extern string  Symbols       = "USDJPY;EURJPY;CHFJPY;GBPJPY;AUDJPY;NZDJPY;CADJPY;EURGBP;EURCHF;EURCAD;CADCHF;EURUSD;USDCHF;GBPUSD;AUDUSD;NZDUSD;USDCAD;AUDNZD;EURAUD;EURNZD;GBPCHF;GBPAUD;GBPNZD;GBPCAD;AUDCHF;AUDCAD;NZDCHF;NZDCAD"; // List of symbols (separated by ";")
extern string  UniqueID      = " ";
extern ENUM_BASE_CORNER Corner = 0;
extern int     Row = 10;
extern int     X_Shift        = 12;
extern int     Y_Shift        = 2;
extern int     X_Size         = 76;
extern int     Y_Size         = 20;
extern int     Font_Size         = 10;
extern color   Button_color        = clrRoyalBlue;
extern color   Border_color        = clrBlack;
extern color   Text_color       = clrWhite;
extern color   Text_color_selected       = clrRed;
extern bool    Transparent   = false;


string aSymbols[];
int OnInit() 
{
IndicatorShortName(UniqueID); 
   Symbols = StringTrimLeft(StringTrimRight(Symbols));
   if (StringSubstr(Symbols,StringLen(Symbols)-1,1) != ";")
                    Symbols = StringConcatenate(Symbols,";");


         int s=0,i=StringFind(Symbols,";",s);
         string current;
         while (i > 0)
         {
            current = StringSubstr(Symbols,s,i-s);
               ArrayResize(aSymbols,ArraySize(aSymbols)+1);
                           aSymbols[ArraySize(aSymbols)-1] = current;
                           s = i + 1;
                           i = StringFind(Symbols,";",s);
         }


   int xpos=0,ypos=0,maxx=0,maxy=0; 
         for (i = 0; i<ArraySize(aSymbols); i++)
            { if (i>0 && MathMod(i,Row)==0) { xpos=0; ypos+=Y_Size+1; } createButton(UniqueID+":symbol:"+string(i),aSymbols[i],X_Shift+xpos,Y_Shift+ypos); xpos +=X_Size+1; }                     
   xpos = 0; ypos += Y_Size*1.4;     
         for (i = 0; i<ArraySize(sTfTable); i++)
            { if (i>0 && MathMod(i,Row)==0) { xpos=0; ypos+=Y_Size+1; } createButton(UniqueID+":time:"+string(i),sTfTable[i],X_Shift+xpos,Y_Shift+ypos); xpos +=X_Size+1; }                     


   setSymbolButtonColor();
   setTimeFrameButtonColor();
   return(0);   
}
void OnDeinit(const int reason)
{ 
   switch(reason)
   {
      case REASON_CHARTCHANGE :
      case REASON_RECOMPILE   :
      case REASON_CLOSE       : break;
      default :
      {
         string lookFor       = UniqueID+":";
         int    lookForLength = StringLen(lookFor);
         for (int i=ObjectsTotal()-1; i>=0; i--)
         {
               string objectName = ObjectName(i);  if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
         }
      }                  
   }
}

#property copyright "DAI"
#property  link      "https://aspergerz.biz/"
#property version "2"

void createButton(string name, string caption, int xpos, int ypos)
{
   int window = WindowFind(UniqueID);
       ObjectCreate(name,OBJ_BUTTON,window,0,0);
          ObjectSet(name,OBJPROP_CORNER,Corner);
          ObjectSet(name,OBJPROP_XDISTANCE,xpos);
          ObjectSet(name,OBJPROP_YDISTANCE,ypos);
          ObjectSet(name,OBJPROP_XSIZE,X_Size);
          ObjectSet(name,OBJPROP_YSIZE,Y_Size);
          ObjectSetText(name,caption,Font_Size,"Arial",Text_color);
              ObjectSet(name,OBJPROP_FONTSIZE,Font_Size);
              ObjectSet(name,OBJPROP_BORDER_TYPE,BORDER_FLAT);
              ObjectSet(name,OBJPROP_COLOR,Text_color); 
              ObjectSet(name,OBJPROP_BGCOLOR,Button_color); 
              ObjectSet(name,OBJPROP_BACK,Transparent); 
              ObjectSet(name,OBJPROP_BORDER_COLOR,Border_color); 
              ObjectSet(name,OBJPROP_STATE,false);
              ObjectSet(name,OBJPROP_HIDDEN,true);
}

void setSymbolButtonColor()
{
   string lookFor       = UniqueID+":symbol:";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);  
      if (StringSubstr(objectName,0,lookForLength) == lookFor)
      {
         string symbol = ObjectGetString(0,objectName,OBJPROP_TEXT);
         if (symbol != _Symbol)
               ObjectSet(objectName,OBJPROP_COLOR,Text_color); 
         else  ObjectSet(objectName,OBJPROP_COLOR,Text_color_selected);
      }         
   }
}
void setTimeFrameButtonColor()
{
   string lookFor       = UniqueID+":time:";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);  
      if (StringSubstr(objectName,0,lookForLength) == lookFor)
      {
         int time = stringToTimeFrame(ObjectGetString(0,objectName,OBJPROP_TEXT));
         if (time != _Period)
               ObjectSet(objectName,OBJPROP_COLOR,Text_color); 
         else  ObjectSet(objectName,OBJPROP_COLOR,Text_color_selected);
      }         
   }
}

//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{  //dai_DS
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
int stringToTimeFrame(string tf)
{
   for (int i=ArraySize(sTfTable)-1; i>=0; i--) 
         if (tf==sTfTable[i]) return(iTfTable[i]);
                              return(0);
}

//
//
//
//
//

void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam)
{
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {
      if (StringFind(sparam,UniqueID+":symbol:",0)==0) ChartSetSymbolPeriod(0,ObjectGetString(0,sparam,OBJPROP_TEXT),_Period);
      if (StringFind(sparam,UniqueID+":time:"  ,0)==0) ChartSetSymbolPeriod(0,_Symbol,stringToTimeFrame(ObjectGetString(0,sparam,OBJPROP_TEXT)));
      if (StringFind(sparam,UniqueID+":back:"  ,0)==0) ObjectSet(sparam,OBJPROP_STATE,false);
   }
}  

//
//
//
//
//

int start() { return(0); }